flibrary Macs {
	macro HDF4ReaderUI{
		LBL_APPS.HDF4Reader.Mods.readHDF4Params &readHDF4Params<export=2, NEportLevels={2,1}>;

   	UImod_panel UImod_panel<NEx=-253.,NEy=-22.> {
      	option {
         	set = 1;
				title => "ReadHDF4";
				width = 400;
      	};
   	};
   	UIlabel UIlabelFilename {
      	parent => <-.UImod_panel;
      	label => "Filename";
      	y = 0;
   	};
   	UItext UItextFilename <NEportLevels={0,2}>{
      	parent => <-.UImod_panel;
      	y = 24;
      	width = 200;
			text => <-.readHDF4Params.filename;
   	};
		UIbutton BrowseButton<NEx=198.,NEy=374.> {
            parent => <-.UImod_panel;
            height = 30;
            label<NEdisplayMode="open"> => "browse";
            x = 200;
            y = 24;
         };
         UIfileSB FileBrowser<NEx=363.,NEy=176.> {
            visible => <-.BrowseButton.do;
            filename<NEportLevels={2,2}> => <-.readHDF4Params.filename;
            x = 692;
            y = 510;
            width = 300;
            height = 388;
            ok = 1;
            cancel = 1;
         };

   	UIlabel UIlabelFieldNumber <NEportLevels={0,2}>{
      	parent => <-.UImod_panel;
      	label<NEdisplayMode="open"> => "Field Number";
      	y = 60;
   	};
   	UIfield UIfield {
      	parent => <-.UImod_panel;
      	value<NEportLevels={2,2}> => <-.readHDF4Params.field_number ;
      	y = 60;
      	x = 100;
      	min = 0.;
   	};

	UIlabel max <NEportLevels={0,2}>{
        parent => <-.UImod_panel;
        label<NEdisplayMode="open"> => str_format("%s %d", "max", <-.<-.readHDF4.max_field);
        y = 60;
	x = 200;
        };
	
   	UIoptionMenu UIoptionMenu {
      	parent => <-.UImod_panel;
      	cmdList => {<-.UIoptionC,
         	<-.UIoptionF77};
      	selectedItem<NEportLevels={0,3}> => <-.readHDF4Params.data_layout;
      	label => "Data Layout";
      	x = 0;
      	y = 108;
   	};
   	UIoption UIoptionC {
      	label => "C";
   	};
   	UIoption UIoptionF77 {
      	label => "F77";
      	set = 1;
   	};
		UItoggle UItoggleDebug {
			parent => <-.UImod_panel;
			label => "Debug";	
			set<NEportLevels={0,3}> =>  <-.readHDF4Params.debug;
			x = 0;
			y = 150;
		};
	};


	macro HDF4Reader {
		LBL_APPS.HDF4Reader.Mods.readHDF4Params readHDF4Params<export=2, NEportLevels={0,1}>;
		LBL_APPS.HDF4Reader.Mods.readHDF4 readHDF4<export=2>  {
			readHDF4Params => <-.readHDF4Params;
		};	
		HDF4ReaderUI HDF4ReaderUI<export=2>{
			readHDF4Params => <-.readHDF4Params;
			UIfield.max+nres => readHDF4.max_field;	
		};
		link out<NEportLevels={1,2}> => readHDF4.output;
	};

APPS.SingleWindowApp HDF4ReaderEg <NEdisplayMode="maximized"> {
   UI {
      Modules {
         IUI {
            optionList {
               selectedItem = 0;
            };
         };
      };
   };
   GDM.Uviewer3D Uviewer3D<NEx=816,NEy=600> {
      Scene {
         Top {
            child_objs => {
               <-.<-.<-.orthoslice.out_obj};
         };
      };
   };
   LBL_APPS.HDF4Reader.Macs.HDF4Reader HDF4Reader<NEx=198.,NEy=99.>;
   MODS.orthoslice orthoslice<NEx=297.,NEy=264.> {
      in_field => <-.HDF4Reader.out;
   };
};

};
